Subject: [bug#33575] [PATCH] guix: lint: Add checker to check if inputs are sorted.

From: [email-masked] (宋文武)
Date: Mon, 10 Dec 2018 19:45:24 +0800

Maxim Cournoyer <[email-masked]> writes:

> Hi,
>
> Arun Isaac <[email-masked]> writes:
>
>>> If they are sorted, I have to add comment for each test input:
>>>
>>>   `(("aspell-dict-en", aspecll-dict-en) ; for test
>>>     ("glib" ,glib "bin")
>>>     ("pkg-config" ,pkg-config)
>>>     ("xmllint" ,libxml2)
>>>     ("xorg-server" ,xorg-server))       ; for test
>>>
>>> Which will be a little annoying...
>>
>> I too find this convincing. It's not a good idea to enforce sorted
>> inputs all the time. If there is sufficient consensus, we can close this
>> bug report.
>
> Maybe our test inputs should have their own field? This would make their
> raison d'être explicit and remove the need of using comments.

Yeah, something like:

  (package
    ...
    (inputs ...)
  (test:inputs ...)
  (test:native-inputs ...))

If we plan to support build packages with tests disabled, this would be
the way to go.  And due to how build works in guix, if tests are
disabled, it would be considered as a different derivation/package, so
the main use case may be:

  - I disable substitute servers to build all packages from sources
    locally.
  - I want to disable tests for some packages as they are too slow...

I don't have this use case now, and seperate package inputs will be a
big change, so I think the current way is totally ok.